/* Create Related PR */
app.custom.formTasks.add('Incident', "Create Related PR", function (formObj, viewModel) {
	CreateRelatedPR();
 });
/*Create Related PR */
function CreateRelatedPR () {
    //Class Id for pr
    var classid = "422afc88-5eff-f4c5-f8f6-e01038cde67f";
    //Call the Get Templates Web Service to return all PR Templates
    $.ajax({
        url: "/api/V3/Template/GetTemplates",
        data: {classId: classid},
        type: "GET",
        success: function (data) {
            console.log (data)
            //Call the loadTemplates Function and send it the PR Template Names and Id's
            loadTemplates(data);
        }
    });

    function loadTemplates (templateData){
        //use requirejs to load the HTML template first
        require(["text!/CustomSpace/ext_SelectPR_template.html"], 
            function (htmlTemplate) {
                //make a jQuery obj
                templateObj = $(htmlTemplate);

                //create a view model to handle the UX
                var _vmWindow = new kendo.observable({
                    dropDownData: templateData,
                    valueChanged : function(e) {
                        var dataItem = e.sender.dataItem();
                        console.log (dataItem.Id)
                    },
                    okClick: function () {
                        var templateId = $("#templateselected option:selected").val();
                        console.log(templateId);
                        //They clicked OK now call the Create PR function and send the Template ID that is selected
                        createProblem(templateId, pageForm.viewModel);
                        customWindow.close();
                    },
                    cancelClick: function () {
                        customWindow.close();

                    }
                });
             
                //create the kendo window
                customWindow = templateObj.kendoWindow({
                    title: "Create Related PR",
                    resizable: false,
                    modal: true,
                    viewable: false,
                    width: 500,
                    height: 300,
                    close: function () {
             
                    },
                    activate: function () {
                        //on window activate bind the view model to the loaded template content
                        kendo.bind(templateObj, _vmWindow);
                    }
                }).data("kendoWindow");
             
                //now open the window
                customWindow.open().center();
            }
        );
    }
    function createProblem (templateId, vm_IR) {
		//Logged in User Id
        var uid = session.user.Id;
        //console.log(uid);
        $.ajax({
            url: "/api/V3/Projection/CreateProjectionByTemplate",
            data: {id: templateId, createdById: uid},
            type: "GET",
            success: function (data) {
                console.log(data);
				
				//Get the IR information and copy it to the new PR
                data.Title = vm_IR.Title;
				data.AssignedWorkItem = vm_IR.AssignedWorkItem;
                data.RequestedWorkItem = [{
                    ClassTypeId: vm_IR.RequestedWorkItem.ClassTypeId,
                    BaseId: vm_IR.RequestedWorkItem.BaseId,
                    DisplayName: vm_IR.RequestedWorkItem.DisplayName
					
                }];
                data.CreatedWorkItem = [{
                    ClassTypeId: "a604b942-4c7b-2fb2-28dc-61dc6f465c68",
                    BaseId: session.user.Id,
                    DisplayName: session.user.Name
                }];
                data.RelatesToWorkItem = [{
                    ClassTypeId: vm_IR.ClassTypeId,
                    BaseId: vm_IR.BaseId,
                    Id: vm_IR.Id
                }];
                //console.log (data)
                var PRId = data.Id;
                var strData = { "formJson":{"current": data }}
                $.ajax({
                    url: "/api/V3/Projection/Commit",
                    type: "POST",
                    contentType: "application/json; charset=utf-8",
                    dataType: "json",
                    data: JSON.stringify(strData) ,
                    success: function (data2) {
						window.location.href = window.location.protocol + "//" + window.location.hostname + "/Problem/Edit/" + PRId
                    }
                });                                 
            }
        });
    };

}